/*******************************************************************************
 * Copyright (c) 2000, 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 * D Port:
 *     Bill Baxter <wbaxter> at gmail com
 *******************************************************************************/
module snippets.canvas.Snippet290;

/* 
 * Canvas snippet: ignore 2nd mouse up event after double-click
 *
 * For a list of all SWT example snippets see
 * http://www.eclipse.org/swt/snippets/
 */

import dwt.widgets.Display;
import dwt.widgets.Shell;
import dwt.events.MouseEvent;
import dwt.events.MouseAdapter;

import tango.io.Stdout;

void main() {
	final Display display = new Display();
	final Shell shell = new Shell(display);
	shell.addMouseListener(new class MouseAdapter {
		public void mouseUp(MouseEvent e) {
			if (e.count == 1) {
				Stdout("Mouse up").newline;
			}
		}
		public void mouseDoubleClick(MouseEvent e) {
            Stdout("Double-click").newline;
		}
	});
	shell.setBounds(10, 10, 200, 200);
	shell.open ();
	while (!shell.isDisposed()) {
		if (!display.readAndDispatch()) display.sleep();
	}
	display.dispose();
}

